AspectJAfterReturningAdvice (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.aop.aspectj

## Class AspectJAfterReturningAdvice

- java.lang.Object
- - org.springframework.aop.aspectj.AbstractAspectJAdvice
  - - org.springframework.aop.aspectj.AspectJAfterReturningAdvice

- All Implemented Interfaces:
    Advice, AfterAdvice, AfterReturningAdvice, AspectJPrecedenceInformation, Ordered

      public class AspectJAfterReturningAdvice
      extends AbstractAspectJAdvice
      implements AfterReturningAdvice, AfterAdvice

  Spring AOP advice wrapping an AspectJ after-returning advice method.
  Since:
    2.0
  Author:
    Rod Johnson, Juergen Hoeller, Ramnivas Laddad

- - ### Field Summary

    - ### Fields inherited from class org.springframework.aop.aspectj.AbstractAspectJAdvice

      `aspectJAdviceMethod, JOIN_POINT_KEY`

    - ### Fields inherited from interface org.springframework.core.Ordered

      `HIGHEST_PRECEDENCE, LOWEST_PRECEDENCE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AspectJAfterReturningAdvice(Method aspectJBeforeAdviceMethod, AspectJExpressionPointcut pointcut, AspectInstanceFactory aif)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterReturning(Object returnValue, Method method, Object[] args, Object target)` Callback after a given method successfully returned.
    `boolean` | `isAfterAdvice()` Return whether this is an after advice.
    `boolean` | `isBeforeAdvice()` Return whether this is a before advice.
    `void` | `setReturningName(String name)`

    - ### Methods inherited from class org.springframework.aop.aspectj.AbstractAspectJAdvice

      `argBinding, buildSafePointcut, calculateArgumentBindings, createParameterNameDiscoverer, currentJoinPoint, getAspectClassLoader, getAspectInstanceFactory, getAspectJAdviceMethod, getAspectName, getDeclarationOrder, getDiscoveredReturningGenericType, getDiscoveredReturningType, getDiscoveredThrowingType, getJoinPoint, getJoinPointMatch, getJoinPointMatch, getOrder, getPointcut, invokeAdviceMethod, invokeAdviceMethod, invokeAdviceMethodWithGivenArgs, setArgumentNames, setArgumentNamesFromStringArray, setAspectName, setDeclarationOrder, setReturningNameNoCheck, setThrowingName, setThrowingNameNoCheck, supportsProceedingJoinPoint, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AspectJAfterReturningAdvice

          public AspectJAfterReturningAdvice(Method aspectJBeforeAdviceMethod,
                                     AspectJExpressionPointcut pointcut,
                                     AspectInstanceFactory aif)

  - ### Method Detail

    - #### isBeforeAdvice

          public boolean isBeforeAdvice()

      Description copied from interface: `AspectJPrecedenceInformation`
      Return whether this is a before advice.
      Specified by:
        `isBeforeAdvice` in interface `AspectJPrecedenceInformation`

    - #### isAfterAdvice

          public boolean isAfterAdvice()

      Description copied from interface: `AspectJPrecedenceInformation`
      Return whether this is an after advice.
      Specified by:
        `isAfterAdvice` in interface `AspectJPrecedenceInformation`

    - #### setReturningName

          public void setReturningName(String name)

      Overrides:
        `setReturningName` in class `AbstractAspectJAdvice`

    - #### afterReturning

          public void afterReturning(Object returnValue,
                            Method method,
                            Object[] args,
                            Object target)
                              throws Throwable

      Description copied from interface: `AfterReturningAdvice`
      Callback after a given method successfully returned.
      Specified by:
        `afterReturning` in interface `AfterReturningAdvice`
      Parameters:
        `returnValue` - the value returned by the method, if any
        `method` - method being invoked
        `args` - arguments to the method
        `target` - target of the method invocation. May be `null`.
      Throws:
        `Throwable` - if this object wishes to abort the call. Any exception thrown will be returned to the caller if it's allowed by the method signature. Otherwise the exception will be wrapped as a runtime exception.